# CesiumTerrainProvider

#### new Cesium.CesiumTerrainProvider(options)
Core/CesiumTerrainProvider.js 93

  A `TerrainProvider` that access terrain data in a Cesium terrain format. The format is described on the Cesium wiki.

  Name | Type | Description
  --- | --- | ---

  `options`

  Object

  Object with the following properties:

  Name | Type | Default | Description
  --- | --- | --- | ---
  `url` | String |  | The URL of the Cesium terrain server.
  `proxy` | Proxy |  | optional A proxy to use for requests. This object is expected to have a getURL function which returns the proxied URL, if needed.
  `requestVertexNormals` | Boolean | `false` | optional Flag that indicates if the client should request additional lighting information from the server, in the form of per vertex normals if available.
  `requestWaterMask` | Boolean | `false` | optional Flag that indicates if the client should request per tile water masks from the server, if available.
  `ellipsoid` | Ellipsoid |  | optional The ellipsoid. If not specified, the WGS84 ellipsoid is used.
  `credit` | Credit | String |  | optional A credit for the data source, which is displayed on the canvas.

  ##### Example:

      // Construct a terrain provider that uses per vertex normals for lighting
      // to add shading detail to an imagery provider.
      var terrainProvider = new Cesium.CesiumTerrainProvider({
          url : 'https://assets.agi.com/stk-terrain/world',
          requestVertexNormals : true
      });

      // Terrain geometry near the surface of the globe is difficult to view when using NaturalEarthII imagery,
      // unless the TerrainProvider provides additional lighting information to shade the terrain (as shown above).
      var imageryProvider = Cesium.createTileMapServiceImageryProvider({
             url : 'http://localhost:8080/Source/Assets/Textures/NaturalEarthII',
             fileExtension : 'jpg'
         });

      var viewer = new Cesium.Viewer('cesiumContainer', {
          imageryProvider : imageryProvider,
          baseLayerPicker : false,
          terrainProvider : terrainProvider
      });

      // The globe must enable lighting to make use of the terrain's vertex normals
      viewer.scene.globe.enableLighting = true;

  ##### See:

  - TerrainProvider

### Members

#### credit : Credit
Core/CesiumTerrainProvider.js 561

  Gets the credit to display when this terrain provider is active. Typically this is used to credit the source of the terrain. This function should not be called before `CesiumTerrainProvider#ready` returns true.

#### errorEvent : Event
Core/CesiumTerrainProvider.js 549

  Gets an event that is raised when the terrain provider encounters an asynchronous error. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### hasVertexNormals : Boolean
Core/CesiumTerrainProvider.js 642

  Gets a value indicating whether or not the requested tiles include vertex normals. This function should not be called before `CesiumTerrainProvider#ready` returns true.

#### hasWaterMask : Boolean
Core/CesiumTerrainProvider.js 623

  Gets a value indicating whether or not the provider includes a water mask. The water mask indicates which areas of the globe are water rather than land, so they can be rendered as a reflective surface with animated waves. This function should not be called before `CesiumTerrainProvider#ready` returns true.

#### ready : Boolean
Core/CesiumTerrainProvider.js 596

  Gets a value indicating whether or not the provider is ready for use.

#### readonlyreadyPromise : Promise.<Boolean>
Core/CesiumTerrainProvider.js 608

  Gets a promise that resolves to true when the provider is ready for use.

#### requestVertexNormals : Boolean
Core/CesiumTerrainProvider.js 662

  Boolean flag that indicates if the client should request vertex normals from the server. Vertex normals data is appended to the standard tile mesh data only if the client requests the vertex normals and if the server provides vertex normals.

#### requestWaterMask : Boolean
Core/CesiumTerrainProvider.js 675

  Boolean flag that indicates if the client should request a watermask from the server. Watermask data is appended to the standard tile mesh data only if the client requests the watermask and if the server provides a watermask.

#### tilingScheme : GeographicTilingScheme
Core/CesiumTerrainProvider.js 579

  Gets the tiling scheme used by this provider. This function should not be called before `CesiumTerrainProvider#ready` returns true.

### Methods

#### getLevelMaximumGeometricError(level) → Number
Core/CesiumTerrainProvider.js 688

  Gets the maximum geometric error allowed in a tile at a given level.

  Name | Type | Description
  --- | --- | ---
  `level` | Number | The tile level for which to get the maximum geometric error.

  ##### Returns:

  The maximum geometric error.

#### getTileDataAvailable(x, y, level) → Boolean
Core/CesiumTerrainProvider.js 734

  Determines whether data for a tile is available to be loaded.

  Name | Type | Description
  --- | --- | ---
  `x` | Number | The X coordinate of the tile for which to request geometry.
  `y` | Number | The Y coordinate of the tile for which to request geometry.
  `level` | Number | The level of the tile for which to request geometry.

  ##### Returns:

  Undefined if not supported, otherwise true or false.

#### requestTileGeometry(x, y, level, throttleRequests) → Promise.<TerrainData>|undefined
Core/CesiumTerrainProvider.js 485

  Requests the geometry for a given tile. This function should not be called before `CesiumTerrainProvider#ready` returns true. The result must include terrain data and may optionally include a water mask and an indication of which child tiles are available.

  Name | Type | Default | Description
  --- | --- | --- | ---
  `x` | Number |  | The X coordinate of the tile for which to request geometry.
  `y` | Number |  | The Y coordinate of the tile for which to request geometry.
  `level` | Number |  | The level of the tile for which to request geometry.
  `throttleRequests` | Boolean | `true` | optional True if the number of simultaneous requests should be limited, or false if the request should be initiated regardless of the number of requests already in progress.

  ##### Returns:

  A promise for the requested geometry. If this method returns undefined instead of a promise, it is an indication that too many requests are already pending and the request will be retried later.

  ##### Throws:

  - DeveloperError : This function must not be called before `CesiumTerrainProvider#ready` returns true.